//----------------------------------------------------------------------
//							Timer Delay 
//				   Write By Mohammad mazarei @ 1390/6/17
//					Email: mohammad.mazarei@gmail.com
//----------------------------------------------------------------------
#ifndef _TDELAY_INCLUDED_
#define _TDELAY_INCLUDED_
#include<AT91SAM7X256.h>
#include <lib_at91sam7x256.h>
#include "tdelay.h"
static int LOAD_RC;

unsigned int GET_MASTER_CPU_CLOCK (void)  
{
	unsigned int reg = AT91C_BASE_PMC->PMC_MCKR;
	unsigned int prescaler = (1 << ((reg & AT91C_PMC_PRES) >> 2));
	unsigned int pllDivider, pllMultiplier;

	switch (reg & AT91C_PMC_CSS) {
		case AT91C_PMC_CSS_SLOW_CLK: // Slow clock selected
			return INRC_CLK / prescaler;
		case AT91C_PMC_CSS_MAIN_CLK: // Main clock is selected
			return EX_XTAL / prescaler;
		case AT91C_PMC_CSS_PLL_CLK: // PLLB clock is selected
			reg = AT91C_BASE_CKGR->CKGR_PLLR;
			pllDivider    = (reg  & AT91C_CKGR_DIV);
			pllMultiplier = ((reg  & AT91C_CKGR_MUL) >> 16) + 1;
			return  EX_XTAL / pllDivider * pllMultiplier / prescaler;
	}
	return 0;
}


  	
void init_delay(void){
	  unsigned int F_CPU= GET_MASTER_CPU_CLOCK();
	  LOAD_RC = F_CPU/8000000;
   *AT91C_PMC_PCER = (1<< AT91C_ID_TC2) ;
   AT91C_BASE_TC2->TC_CMR = (1<<15)| 1 | (1<<6) ; // Colock IS DiV Dy 8
   AT91C_BASE_TC2->TC_RC = LOAD_RC;//(unsigned long)TIMERCLK;
   
}


void delay_us(unsigned int us){
	 //unsigned long _us=us;
	 AT91C_BASE_TC2->TC_RC = (int) LOAD_RC*us;	
	* AT91C_TC2_CCR=0X05; 
	while((AT91C_BASE_TC2->TC_SR&0x10)==0);
}

void delay_ms(unsigned long ms){
	 unsigned long _ms=ms;
	 AT91C_BASE_TC2->TC_RC = LOAD_RC*1000;//(unsigned long)TIMERCLK;	
	while(_ms>0){
		* AT91C_TC2_CCR=0X05; 
	while((AT91C_BASE_TC2->TC_SR&0x10)==0);
		 _ms--;
		 }
}

#endif

